#ifndef _LINUX_NETDEVICE_H
#define _LINUX_NETDEVICE_H

#include <linux/skbuff.h>

#define MAX_ADDR_LEN        8

#define NETIF_F_DYNALLOC    16

struct Qdisc
{
    struct sk_buff_head q;
};

struct net_device
{
    unsigned short  flags;
    unsigned        mtu;
    unsigned short  type;
    unsigned short  hard_header_len;
    unsigned char   broadcast[MAX_ADDR_LEN];
    unsigned char   dev_addr[MAX_ADDR_LEN];
    unsigned char   addr_len;
    void*           atalk_ptr;
    struct Qdisc*   qdisc; 
    unsigned long   tx_queue_len;
    int             features; 
    int             (*do_ioctl)(struct net_device *dev, struct ifreq *ifr, int cmd);
};

struct net_device_stats
{
    unsigned long   rx_packets;
    unsigned long   tx_packets;
};

int dev_queue_xmit(struct sk_buff* skb);

#endif